// Helper functions to generate menus for day and month selection

void generate_day_menu(int day, int type)
{
    int i=0;
    char tmp[4];
    if (type == 1)
        strcat(user_str,"<label><select name=\"daynr_once\" size=\"1\">");
    else if (type == 2)
        strcat(user_str,"<label><select name=\"daynr_month\" size=\"1\">");
    else if (type == 3)
        strcat(user_str,"<label><select name=\"daynr_year\" size=\"1\">");
    for (i=1;i<32;i++)
        {
        itoa(i,tmp,10);
        if (i == day)
            strcat(user_str,"<option selected>");
        else
            strcat(user_str,"<option>");
        strcat(user_str,tmp);
        strcat(user_str,"</option>");
        }
    strcat(user_str,"</select></label>");
}

void generate_month_entry(int month)
{
    switch(month) 
        {
        case(1):
            strcat(user_str,"Jan");
            break;
        case(2):
            strcat(user_str,"Feb");
            break;
        case(3):
            strcat(user_str,"Mar");
            break;
        case(4):
            strcat(user_str,"Apr");
            break;
        case(5):
            strcat(user_str,"May");
            break;
        case(6):
            strcat(user_str,"June");
            break;
        case(7):
            strcat(user_str,"July");
            break;
        case(8):
            strcat(user_str,"Aug");
            break;
        case(9):
            strcat(user_str,"Sep");
            break;
        case(10):
            strcat(user_str,"Oct");
            break;
        case(11):
            strcat(user_str,"Nov");
            break;
        case(12):
            strcat(user_str,"Dez");
            break;
        default:
            strcat(user_str,"");
        }
}

void generate_month_menu(int month, int type)
{
    if (type == 1)
        strcat(user_str,"<label><select name=\"monthnr_once\" size=\"1\">");
    else
        strcat(user_str,"<label><select name=\"monthnr_year\" size=\"1\">");       
    switch(month) 
        {
        case(1):
            strcat(user_str,"<option selected>Jan</option><option>Feb</option><option>Mar</option><option>Apr</option><option>May</option><option>June</option><option>July</option><option>Aug</option><option>Sep</option><option>Oct</option><option>Nov</option><option>Dec</option>");
            break;
        case(2):
            strcat(user_str,"<option>Jan</option><option selected>Feb</option><option>Mar</option><option>Apr</option><option>May</option><option>June</option><option>July</option><option>Aug</option><option>Sep</option><option>Oct</option><option>Nov</option><option>Dec</option>");
            break;
        case(3):
            strcat(user_str,"<option>Jan</option><option>Feb</option><option selected>Mar</option><option>Apr</option><option>May</option><option>June</option><option>July</option><option>Aug</option><option>Sep</option><option>Oct</option><option>Nov</option><option>Dec</option>");
            break;
        case(4):
            strcat(user_str,"<option>Jan</option><option>Feb</option><option>Mar</option><option selected>Apr</option><option>May</option><option>June</option><option>July</option><option>Aug</option><option>Sep</option><option>Oct</option><option>Nov</option><option>Dec</option>");
            break;
        case(5):
            strcat(user_str,"<option>Jan</option><option>Feb</option><option>Mar</option><option>Apr</option><option selected>May</option><option>June</option><option>July</option><option>Aug</option><option>Sep</option><option>Oct</option><option>Nov</option><option>Dec</option>");
            break;
        case(6):
            strcat(user_str,"<option>Jan</option><option>Feb</option><option>Mar</option><option>Apr</option><option>May</option><option selected>June</option><option>July</option><option>Aug</option><option>Sep</option><option>Oct</option><option>Nov</option><option>Dec</option>");
            break;
        case(7):
            strcat(user_str,"<option>Jan</option><option>Feb</option><option>Mar</option><option>Apr</option><option>May</option><option>June</option><option selected>July</option><option>Aug</option><option>Sep</option><option>Oct</option><option>Nov</option><option>Dec</option>");
            break;
        case(8):
            strcat(user_str,"<option>Jan</option><option>Feb</option><option>Mar</option><option>Apr</option><option>May</option><option>June</option><option>July</option><option selected>Aug</option><option>Sep</option><option>Oct</option><option>Nov</option><option>Dec</option>");
            break;
        case(9):
            strcat(user_str,"<option>Jan</option><option>Feb</option><option>Mar</option><option>Apr</option><option>May</option><option>June</option><option>July</option><option>Aug</option><option selected>Sep</option><option>Oct</option><option>Nov</option><option>Dec</option>");
            break;
        case(10):
            strcat(user_str,"<option>Jan</option><option>Feb</option><option>Mar</option><option>Apr</option><option>May</option><option>June</option><option>July</option><option>Aug</option><option>Sep</option><option selected>Oct</option><option>Nov</option><option>Dec</option>");
            break;
        case(11):
            strcat(user_str,"<option>Jan</option><option>Feb</option><option>Mar</option><option>Apr</option><option>May</option><option>June</option><option>July</option><option>Aug</option><option>Sep</option><option>Oct</option><option selected>Nov</option><option>Dec</option>");
            break;
        case(12):
            strcat(user_str,"<option>Jan</option><option>Feb</option><option>Mar</option><option>Apr</option><option>May</option><option>June</option><option>July</option><option>Aug</option><option>Sep</option><option>Oct</option><option>Nov</option><option selected>Dec</option>");
            break;
        default:
            strcat(user_str,"<option selected>Jan</option><option>Feb</option><option>Mar</option><option>Apr</option><option>May</option><option>June</option><option>July</option><option>Aug</option><option>Sep</option><option>Oct</option><option>Nov</option><option>Dec</option>");
        }
    strcat(user_str,"</select></label>");
}

void generate_week_entry(int tm_wday_tmp)
{
    switch(tm_wday_tmp) 
        {
        case(0):
            strcat(user_str,"Sun");
            break;
        case(1):
            strcat(user_str,"Mon");
            break;
        case(2):
            strcat(user_str,"Tue");
            break;
        case(3):
            strcat(user_str,"Wed");
            break;
        case(4):
            strcat(user_str,"Thu");
            break;
        case(5):
            strcat(user_str,"Fri");
            break;
        case(6):
            strcat(user_str,"Sat");
            break;
        case(7):
            strcat(user_str,"Work");
            break;
        case(8):
            strcat(user_str,"Wend");
            break;
        default:
            strcat(user_str,"");
        } 
}

void generate_week_menu(int tm_wday_tmp)
{
    switch(tm_wday_tmp) 
        {
        case(0):
            strcat(user_str,"<label><select name=\"day\" size=\"1\"><option>Monday</option><option>Tuesday</option><option>Wednesday</option><option>Thursday</option><option>Friday</option><option>Saturday</option><option selected>Sunday</option><option>Weekend</option><option>Workdays</option></select></label>");
            break;
        case(1):
            strcat(user_str,"<label><select name=\"day\" size=\"1\"><option selected>Monday</option><option>Tuesday</option><option>Wednesday</option><option>Thursday</option><option>Friday</option><option>Saturday</option><option>Sunday</option><option>Weekend</option><option>Workdays</option></select></label>");
            break;
        case(2):
            strcat(user_str,"<label><select name=\"day\" size=\"1\"><option>Monday</option><option selected>Tuesday</option><option>Wednesday</option><option>Thursday</option><option>Friday</option><option>Saturday</option><option>Sunday</option><option>Weekend</option><option>Workdays</option></select></label>");
            break;
        case(3):
            strcat(user_str,"<label><select name=\"day\" size=\"1\"><option>Monday</option><option>Tuesday</option><option selected>Wednesday</option><option>Thursday</option><option>Friday</option><option>Saturday</option><option>Sunday</option><option>Weekend</option><option>Workdays</option></select></label>");
            break;
        case(4):
            strcat(user_str,"<label><select name=\"day\" size=\"1\"><option>Monday</option><option>Tuesday</option><option>Wednesday</option><option selected>Thursday</option><option>Friday</option><option>Saturday</option><option>Sunday</option><option>Weekend</option><option>Workdays</option></select></label>");
            break;
        case(5):
            strcat(user_str,"<label><select name=\"day\" size=\"1\"><option>Monday</option><option>Tuesday</option><option>Wednesday</option><option>Thursday</option><option selected>Friday</option><option>Saturday</option><option>Sunday</option><option>Weekend</option><option>Workdays</option></select></label>");
            break;
        case(6):
            strcat(user_str,"<label><select name=\"day\" size=\"1\"><option>Monday</option><option>Tuesday</option><option>Wednesday</option><option>Thursday</option><option>Friday</option><option selected>Saturday</option><option>Sunday</option><option>Weekend</option><option>Workdays</option></select></label>");
            break;
        case(7):
            strcat(user_str,"<label><select name=\"day\" size=\"1\"><option>Monday</option><option>Tuesday</option><option>Wednesday</option><option>Thursday</option><option>Friday</option><option>Saturday</option><option>Sunday</option><option>Weekend</option><option selected>Workdays</option></select></label>");
            break;
        case(8):
            strcat(user_str,"<label><select name=\"day\" size=\"1\"><option>Monday</option><option>Tuesday</option><option>Wednesday</option><option>Thursday</option><option>Friday</option><option>Saturday</option><option>Sunday</option><option selected>Weekend</option><option>Workdays</option></select></label>");
            break;
        default:
            strcat(user_str,"<label><select name=\"day\" size=\"1\"><option selected>Monday</option><option>Tuesday</option><option>Wednesday</option><option>Thursday</option><option>Friday</option><option>Saturday</option><option>Sunday</option><option>Weekend</option><option>Workdays</option></select></label>");
        }
}

/* HTTP generator */
void generate_response(int gen_page_id)
{
    char temp[4],buf[3];
    int i,tm_recur,tm_wday,tm_daynr,tm_monthnr,tm_hour,tm_min,empty_switch_action_element=0,found_empty_switch_action_element=0,event_id_tmp;
    strcpy(user_str,"<!DOCTYPE html><html><head><meta name=\"viewport\" content=\"width=device-width, initial-scale=1\"><link rel=\"icon\" href=\"data:,\">");
    // CSS to style the on/off buttons 
    // Feel free to change the background-color and font-size attributes to fit your preferences
    strcat(user_str,"<style>html { font-family: Helvetica; display: inline-block; margin: 0px auto; text-align: center;}");
    strcat(user_str,".button { background-color: #195B6A; border: none; color: white; padding: 16px 40px;");
    strcat(user_str,"text-decoration: none; font-size: 30px; margin: 2px; cursor: pointer;}");
    strcat(user_str,".button2 {background-color: #77878A;}</style></head>");
            
    // Web Page Heading
    strcat(user_str,"<body class=\"yui3-skin-sam\" ><h1>");
    strcat(user_str,config.name);
    strcat(user_str,"</h1>");
            
    // Display current state, and ON/OFF buttons
    if (gen_page_id == PORT_ON || gen_page_id == PORT_OFF || gen_page_id == PORT_TIMER)
        {
        strcat(user_str,"<p>Port - State</p>");
        strcat(user_str, "<form action=\"/switch\" method=\"get\" id=\"formid\">");
        if (gen_page_id == PORT_ON)
            {
            strcat(user_str,"<input type=\"radio\" id=\"portstate\" name=\"new_state\" value=\"on\" disabled=\"disabled\" checked=\"checked\"><label for=\"portstate\">ON</label><input type=\"radio\" id=\"portstate\" name=\"new_state\" value=\"off\"><label for=\"portstate\">OFF</label><input type=\"radio\" id=\"portstate\" name=\"new_state\" value=\"tim\"><label for=\"portstate\">TIMER</label> <input type=\"text\" name=\"timer_value\" value=\"\" size=\"3\" maxlength=\"3\"> min<br>");
            }
        else if (gen_page_id == PORT_OFF)
            {
            strcat(user_str,"<input type=\"radio\" id=\"portstate\" name=\"new_state\" value=\"on\"><label for=\"portstate\">ON</label><input type=\"radio\" id=\"portstate\" name=\"new_state\" value=\"off\" disabled=\"disabled\" checked=\"checked\"><label for=\"portstate\">OFF</label><input type=\"radio\" id=\"portstate\" name=\"new_state\" value=\"tim\"><label for=\"portstate\">TIMER</label> <input type=\"text\" name=\"timer_value\" value=\"\" size=\"3\" maxlength=\"3\"> min<br>");
            }
        else if (gen_page_id == PORT_TIMER)
            {
            strcat(user_str,"<input type=\"radio\" id=\"portstate\" name=\"new_state\" value=\"on\"><label for=\"portstate\">ON</label><input type=\"radio\" id=\"portstate\" name=\"new_state\" value=\"off\"><label for=\"portstate\">OFF</label><input type=\"radio\" id=\"portstate\" name=\"new_state\" value=\"tim\" disabled=\"disabled\" checked=\"checked\"><label for=\"portstate\">TIMER</label> <input type=\"text\" name=\"timer_value\" size=\"3\" maxlength=\"3\" disabled=\"disabled\" value=\"");
            itoa(timer_min,temp,10);
            strcat(user_str,temp);
            strcat (user_str, "\"> min<br>");
            }
        if (next_switch_delay == 0 || gen_page_id == PORT_TIMER)
            {
            if (strcmp(config.use_authorization,"yes") == 0)
                strcat(user_str,"<br>Station Password:<br><input type=\"password\" name=\"station_password\" maxlength=\"64\" value=\"\"><br>");
            strcat(user_str,"<p><a href=\"/switch\"><button type=\"submit\">SAVE</button></a></p>");
            }
        else
            strcat(user_str,"<br><br>Executed!<br>Wait 30 secs until next switch is allowed.<br>");
        strcat(user_str,"</form>");
        if (strcmp(config.use_actions,"yes") == 0)
            {
            strcat(user_str,"<div align = \"center\"><br>Planned actions<table border><br><tr><th>Recur</th><th>Month</th><th>Day</th><th>Hour</th><th>Min</th><th>Action</th><th>Status</th><th>Config</th></tr>");
            for (i=0;i<SWITCHLIST_SIZE;i++)
                {
                tm_recur = switch_times[i].recurring;
                tm_wday = switch_times[i].tm_wday;
                tm_daynr = switch_times[i].tm_daynr;
                tm_monthnr = switch_times[i].tm_monthnr;
                tm_hour = switch_times[i].tm_hour;
                tm_min = switch_times[i].tm_min;
                if (switch_times[i].event_status)
                    {
                    strcat(user_str,"<tr>");
                    strcat(user_str,"<td>");
                    switch(tm_recur) 
                        {
                        case(RECUR_ONCE):
                            strcat(user_str,"Once</td><td>");
                            generate_month_entry(tm_monthnr);
                            strcat(user_str,"</td><td>");
                            itoa(tm_daynr,buf,10);
                            strcat(user_str,buf);
                        break;
                        case(RECUR_DAY):
                            strcat(user_str,"Day</td><td>every</td><td>every");                        
                        break;   
                        case(RECUR_WEEK):
                            strcat(user_str,"Week</td><td>every</td><td>");
                            generate_week_entry(tm_wday);
                            break;
                        case(RECUR_MONTH):
                            strcat(user_str,"Month</td><td>every</td><td>");
                            itoa(tm_daynr,buf,10);
                            strcat(user_str,buf); 
                        break;
                        case(RECUR_YEAR):
                            strcat(user_str,"Year</td><td>");
                            generate_month_entry(tm_monthnr);
                            strcat(user_str,"</td><td>");
                            itoa(tm_daynr,buf,10);
                            strcat(user_str,buf);
                        break;
                        }
                    strcat(user_str,"</td><td>");
                    itoa(tm_hour,buf,10);
                    strcat(user_str,buf);
                    strcat(user_str,"</td><td>");
                    itoa(tm_min,buf,10);
                    strcat(user_str,buf);
                    strcat(user_str,"</td><td>");
                    if (switch_times[i].switch_status)
                        strcat(user_str,"on");    
                    else
                        strcat(user_str,"off");
                    strcat(user_str,"</td><td><font color = \"33DD00\">active</font></td><td><a href=\"/configactions?event=");
                    itoa(i,buf,10);
                    strcat(user_str,buf);
                    strcat(user_str,"\">change</a></td></tr>");
                    }
                else if (empty_switch_action_element == 0 && found_empty_switch_action_element == 0)
                    {
                    //keep an empty element for config 
                    empty_switch_action_element = i;
                    found_empty_switch_action_element = 1;
                    }
                }
            strcat(user_str,"</table></div>");  
            if (found_empty_switch_action_element)
                {
                strcat(user_str,"<a href=\"/configactions?event=");
                itoa(empty_switch_action_element,buf,10);
                strcat(user_str,buf);
                strcat(user_str,"\">Add a new planned action</a><br>");
                }
            }
        strcat(user_str,"<br><a href=\"/config\">configure me</a><br>");
        strcat(user_str,"<meta http-equiv=\"refresh\" content=\"30; URL=/\">");
        }
        
    //Display config page
    else if (gen_page_id == CONFIG_MODE || gen_page_id == CONFIG_SAVE || gen_page_id == CONFIG_FAILED)
        {
        if (gen_page_id == CONFIG_SAVE)
            {
            strcat(user_str, "<p>Config updated!<br></p>");
            if (restart_in_progress)
                {
                if (strcmp(config.auto_ota, "yes") == 0)
                    {
                    strcat(user_str,"<p>System is restarting.<br>Reason: Firmware update in progress.<br><br>Port is switched of during restart!<br><br>Page will auto-refresh in 120 seconds.</p>");
                    if (strcmp (config.ip, "") != 0)
                        {
                        strcat(user_str,"<meta http-equiv=\"refresh\" content=\"120; URL=http://");
                        strcat(user_str,config.ip);
                        strcat (user_str, "\">");
                        }
                    else
                        strcat(user_str,"<meta http-equiv=\"refresh\" content=\"120; URL=/\">");
                    }
                else
                    {
                    strcat(user_str, "<p>System is restarting.<br>Reason: Network or Wlan parameters were changed.<br><br>Port is switched of during restart!<br><br>Page will auto-refresh in 15 seconds.</p>");
                    if (strcmp (config.ip, "") != 0)
                        {
                        strcat(user_str,"<meta http-equiv=\"refresh\" content=\"15; URL=http://");
                        strcat(user_str,config.ip);
                        strcat (user_str, "\">");
                        }
                    else
                        strcat(user_str,"<meta http-equiv=\"refresh\" content=\"15; URL=/\">");
                    }
                }
            else
                strcat(user_str,"<p><a href=\"/\"><button type=\"submit\">GO BACK</button></a></p>");
            }
        if (gen_page_id == CONFIG_MODE || gen_page_id == CONFIG_FAILED)
            {
            if (gen_page_id == CONFIG_FAILED)
                strcat(user_str, "<p><font color=\"FF0000\">Set config values failed!</font></p>");
            else
                strcat(user_str,"<p><h2>CONFIG</h2></p>");
            strcat(user_str, "<form action=\"/cfgsav\" method=\"get\" id=\"formid\"><p><h3>Station data</h3></p><hr>");
            if (cfg_err & (1 << 3))
                strcat (user_str, "<font color = \"FF0000\">");
            strcat(user_str,"Station Name(1-32 chars):<br><input type=\"text\" name=\"station\" maxlength=\"32\" value=\"");
            strcat(user_str,config.name);
            strcat (user_str, "\"><br><br>");
            if (cfg_err & (1 << 3))
                strcat (user_str, "</font>");
            if (cfg_err & (1 << 6))
                strcat (user_str, "<font color = \"FF0000\">");
            strcat(user_str,"New Station Password(2-64 chars):<br><input type=\"text\" name=\"station_new_password_1\" maxlength=\"64\" value=\"current password\"><br><br>");
            if (cfg_err & (1 << 6))
                strcat (user_str, "</font>");
            strcat(user_str,"Use password to auth actions ");
            if (strcmp(config.use_authorization,"yes") == 0)
                strcat(user_str,"<input type=\"radio\" id=\"auth\" name=\"use_password\" value=\"yes\" checked=\"checked\"><label for=\"auth\">YES</label><input type=\"radio\" id=\"auth\" name=\"use_password\" value=\"no\"><label for=\"auth\">NO</label><br><br>");
            else
                strcat(user_str,"<input type=\"radio\" id=\"auth\" name=\"use_password\" value=\"yes\"><label for=\"auth\">YES</label><input type=\"radio\" id=\"auth\" name=\"use_password\" value=\"no\" checked=\"checked\"><label for=\"auth\">NO</label><br><br>");
            strcat(user_str,"Use planned actions ");
            if (strcmp(config.use_actions,"yes") == 0)
                strcat(user_str,"<input type=\"radio\" id=\"actions\" name=\"use_actions\" value=\"yes\" checked=\"checked\"><label for=\"actions\">YES</label><input type=\"radio\" id=\"actions\" name=\"use_actions\" value=\"no\"><label for=\"actions\">NO</label><br><br>");
            else
                strcat(user_str,"<input type=\"radio\" id=\"actions\" name=\"use_actions\" value=\"yes\"><label for=\"actions\">YES</label><input type=\"radio\" id=\"actions\" name=\"use_actions\" value=\"no\" checked=\"checked\"><label for=\"actions\">NO</label><br><br>");
            strcat(user_str,"<p><h3><font color = \"DD9900\">Wlan data</font></h3></p><hr>");
           if (cfg_err & (1 << 1))
                strcat (user_str, "<font color = \"FF0000\">");
            strcat(user_str,"Wlan SSID(1-32 chars):<br><input type=\"text\" name=\"SSID\" maxlength=\"32\" value=\"");
            strcat(user_str,config.ssid);
            strcat (user_str, "\"><br><br>");
            if (cfg_err & (1 << 1))
                strcat (user_str, "</font>");
            if (cfg_err & (1 << 2))
                strcat (user_str, "<font color = \"FF0000\">");
            strcat(user_str,"Wlan Password(0-64 chars):<br><input type=\"text\" name=\"Password\" maxlength=\"64\" value=\"");
            if (strlen(config.password) > 0)
                strcat(user_str,"current password");
            else
                strcat(user_str,"");
            strcat(user_str,"\"><br><br>");
            if (cfg_err & (1 << 2))
                strcat (user_str, "</font>");
            strcat(user_str,"<p><h3><font color = \"DD9900\">Network data</font></h3></p><hr>Obtain IP config via ");
            if (strcmp(config.use_dhcp,"yes") == 0)
                strcat(user_str,"<input type=\"radio\" id=\"ip_dhcp\" name=\"use_dhcp\" value=\"yes\" checked=\"checked\"><label for=\"ip_dhcp\">DHCP</label><input type=\"radio\" id=\"ip_static\" name=\"use_dhcp\" value=\"no\"><label for=\"ip_static\">STATIC</label><br>");
            else
                strcat(user_str,"<input type=\"radio\" id=\"ip_dhcp\" name=\"use_dhcp\" value=\"yes\"><label for=\"ip_dhcp\">DHCP</label><input type=\"radio\" id=\"ip_static\" name=\"use_dhcp\" value=\"no\" checked=\"checked\"><label for=\"ip_static\">STATIC</label><br>");
            strcat(user_str,"<hr>Fill out in case of static IP config.<br><br>");
            if (cfg_err & (1 << 5))
                strcat (user_str, "<font color = \"FF0000\">");
            strcat(user_str,"Station IP(x.x.x.x):<br><input type=\"text\" name=\"ip\" maxlength=\"15\" value=\"");
            strcat(user_str,config.ip);
            strcat (user_str, "\"><br><br>");
            strcat(user_str,"Gateway(x.x.x.x):<br><input type=\"text\" name=\"gw\" maxlength=\"15\" value=\"");
            strcat(user_str,config.gw);
            strcat (user_str, "\"><br><br>");
            strcat(user_str,"Netmask(x.x.x.x):<br><input type=\"text\" name=\"netmask\" maxlength=\"15\" value=\"");
            strcat(user_str,config.netmask);
            strcat (user_str, "\"><br><br>");
            strcat(user_str,"DNS1(x.x.x.x):<br><input type=\"text\" name=\"dns1\" maxlength=\"15\" value=\"");
            strcat(user_str,config.dns1);
            strcat (user_str, "\"><br><br>");
            strcat(user_str,"DNS2(x.x.x.x):<br><input type=\"text\" name=\"dns2\" maxlength=\"15\" value=\"");
            strcat(user_str,config.dns2);
            strcat (user_str, "\"><br><br>");
            if (cfg_err & (1 << 5))
                strcat (user_str, "</font>");
            if (strcmp(OTA_SERVER_URL,"") != 0 && strcmp(OTA_SERVER_CERT,"") != 0)
                {
                strcat(user_str,"<p><h3><font color = \"DD9900\">Firmware update</font></h3></p><hr>Do firmware update");
                if (strcmp(config.auto_ota,"yes") == 0)
                    strcat(user_str,"<input type=\"radio\" id=\"ota\" name=\"auto_ota\" value=\"yes\" checked=\"checked\"><label for=\"auth\">YES</label><input type=\"radio\" id=\"ota\" name=\"auto_ota\" value=\"no\"><label for=\"auth\">NO</label><br>");
                else
                    strcat(user_str,"<input type=\"radio\" id=\"ota\" name=\"auto_ota\" value=\"yes\"><label for=\"auth\">YES</label><input type=\"radio\" id=\"ota\" name=\"auto_ota\" value=\"no\" checked=\"checked\"><label for=\"auth\">NO</label><br>");
                strcat(user_str,"Update URL: ");
                strcat(user_str,OTA_SERVER_URL);
                strcat(user_str,"<br>");
                }
            strcat(user_str,"<hr><font color = \"DD9900\">Changes within these sections can cause a restart</font><br><br>");
            if (cfg_err & (1 << 4))
                strcat (user_str, "<font color = \"FF0000\">");
            strcat(user_str,"Station Password:<br><input type=\"password\" name=\"station_password\" maxlength=\"64\" value=\"\"><br>");
            if (cfg_err & (1 << 4))
                strcat (user_str, "</font>");
            if (gen_page_id == CONFIG_FAILED)
                strcat(user_str,"<p><a href=\"/cfgsav\"><button type=\"submit\">SAVE</button></a></p></form><p><a href=\"javascript:history.back()\"><button type=\"submit\">GO BACK</button></a></p>");
            else    
                strcat(user_str,"<p><a href=\"/cfgsav\"><button type=\"submit\">SAVE</button></a></p></form><p><a href=\"/\"><button type=\"submit\">GO BACK</button></a></p>");
            }
        }
        
    //Display Config Actions page
    else if (gen_page_id == CONFIG_ACTIONS_MODE || gen_page_id == CONFIG_ACTIONS_FAILED || gen_page_id == CONFIG_ACTIONS_FAILED_DUP)
        {
        event_id_tmp = atoi(event_id);
        strcat(user_str,"<p>Configure planned action number: ");
        strcat(user_str,event_id);
        strcat(user_str," of max. 40</p>");
        if (gen_page_id == CONFIG_ACTIONS_FAILED)
            strcat(user_str,"<p><font color = \"FF0000\">Config action has failed due to invalid data!</font><br><p>");
        if (gen_page_id == CONFIG_ACTIONS_FAILED_DUP)
            strcat(user_str,"<p><font color = \"FF0000\">Config action has failed!Duplicate planned action found!<br>Showing now data of the duplicate planned action</font><br><p>");
        strcat(user_str,"<p><font color = \"CC7700\">Action hierarchy:<br> Manual timer->Once->Yearly->Monthly->Weekly->Daily</font><p><form action=\"/cfgsavactions\" method=\"get\" id=\"formid\"><br><p><h3>Action Status</h3></p><hr>Active: ");
        if (switch_times[event_id_tmp].event_status)
            strcat(user_str,"<input type=\"radio\" id=\"active\" name=\"event_active\" value=\"yes\" checked=\"checked\"><label for=\"portstate\">YES</label><input type=\"radio\" id=\"active\" name=\"event_active\" value=\"no\"><label for=\"portstate\">NO</label>");
        else
            {
            switch_times[event_id_tmp].tm_wday = 0;
            switch_times[event_id_tmp].tm_daynr = 1;
            switch_times[event_id_tmp].tm_monthnr = 1;
            switch_times[event_id_tmp].tm_hour = 0;
            switch_times[event_id_tmp].tm_min = 0;
            switch_times[event_id_tmp].recurring = RECUR_ONCE;
            switch_times[event_id_tmp].switch_status = 0,
            strcat(user_str,"<input type=\"radio\" id=\"active\" name=\"event_active\" value=\"yes\" checked=\"checked\"><label for=\"portstate\">YES</label><input type=\"radio\" id=\"active\" name=\"event_active\" value=\"no\" disabled=\"disabled\"><label for=\"portstate\">NO</label>");
            }
        strcat(user_str,"<br><br><p><h3>Action Recurring</h3></p><hr><div align=\"center\"><table border=\"0\">");
        //once
        strcat(user_str,"<tr><td>");
        if (switch_times[event_id_tmp].recurring == RECUR_ONCE)
            strcat(user_str,"<input type=\"radio\" id=\"recurring\" name=\"event_recurring\" value=\"once\" checked=\"checked\"><label for=\"recurring\">Once</label>");
        else
            strcat(user_str,"<input type=\"radio\" id=\"recurring\" name=\"event_recurring\" value=\"once\"><label for=\"recurring\">Once</label>");
        strcat(user_str,"</td>");
        strcat(user_str,"<td>");
        strcat(user_str," Day: ");
        if (switch_times[event_id_tmp].recurring == RECUR_ONCE)
            generate_day_menu(switch_times[event_id_tmp].tm_daynr,1);
        else
            generate_day_menu(1,1);
        strcat(user_str," Month: ");
        if (switch_times[event_id_tmp].recurring == RECUR_ONCE)
            generate_month_menu(switch_times[event_id_tmp].tm_monthnr,1);
        else
            generate_month_menu(1,1);
        strcat(user_str,"</td>");
        strcat(user_str,"</tr>");
        //year
        strcat(user_str,"<tr>");
        strcat(user_str,"<td><br>");
        if (switch_times[event_id_tmp].recurring == RECUR_YEAR)
            strcat(user_str,"<input type=\"radio\" id=\"recurring\" name=\"event_recurring\" value=\"yearly\" checked=\"checked\"><label for=\"recurring\">Yearly</label> ");
        else
            strcat(user_str,"<input type=\"radio\" id=\"recurring\" name=\"event_recurring\" value=\"yearly\"><label for=\"recurring\">Yearly</label> ");
        strcat(user_str,"</td><td><br> Day: ");
        if (switch_times[event_id_tmp].recurring == RECUR_YEAR)
            generate_day_menu(switch_times[event_id_tmp].tm_daynr,3);
        else
            generate_day_menu(1,3);
        strcat(user_str," Month: ");
        if (switch_times[event_id_tmp].recurring == RECUR_YEAR)
            generate_month_menu(switch_times[event_id_tmp].tm_monthnr,2);
        else
            generate_month_menu(0,2);
        strcat(user_str,"</td></tr>");
        //month
        strcat(user_str,"<tr><td><br>");
        if (switch_times[event_id_tmp].recurring == RECUR_MONTH)
            strcat(user_str,"<input type=\"radio\" id=\"recurring\" name=\"event_recurring\" value=\"monthly\" checked=\"checked\"><label for=\"recurring\">Monthly</label> ");
        else
            strcat(user_str,"<input type=\"radio\" id=\"recurring\" name=\"event_recurring\" value=\"monthly\"><label for=\"recurring\">Monthly</label> ");
        strcat(user_str,"</td><td><br> Day: ");
        if (switch_times[event_id_tmp].recurring == RECUR_MONTH)
            generate_day_menu(switch_times[event_id_tmp].tm_daynr,2);
        else
            generate_day_menu(1,2);
        strcat(user_str,"</td></tr>");
        //week
        strcat(user_str,"<tr><td><br>");
        if (switch_times[event_id_tmp].recurring == RECUR_WEEK)
            strcat(user_str,"<input type=\"radio\" id=\"recurring\" name=\"event_recurring\" value=\"weekly\" checked=\"checked\"><label for=\"recurring\">Weekly</label> ");
        else
            strcat(user_str,"<input type=\"radio\" id=\"recurring\" name=\"event_recurring\" value=\"weekly\"><label for=\"recurring\">Weekly</label> ");
        strcat(user_str,"</td><td><br>");
        generate_week_menu(switch_times[event_id_tmp].tm_wday);
        strcat(user_str,"</td></tr>");
        //day
        strcat(user_str,"<tr><td><br>");
        if (switch_times[event_id_tmp].recurring == RECUR_DAY)
            strcat(user_str,"<input type=\"radio\" id=\"recurring\" name=\"event_recurring\" value=\"daily\" checked=\"checked\"><label for=\"recurring\">Daily</label>");
        else
            strcat(user_str,"<input type=\"radio\" id=\"recurring\" name=\"event_recurring\" value=\"daily\"><label for=\"recurring\">Daily</label>");
        strcat(user_str,"</td></tr></table></div>");
        itoa (switch_times[event_id_tmp].tm_hour, buf, 10);
        strcat(user_str,"<br><p><h3>Action time</h3></p><hr>hour:<input type=\"text\" name=\"time_hour\" value=\"");
        strcat(user_str,buf);
        strcat(user_str,"\" size=\"2\" maxlength=\"2\">:");
        itoa (switch_times[event_id_tmp].tm_min, buf, 10);
        strcat(user_str," min:<input type=\"text\" name=\"time_min\" value=\"");
        strcat(user_str,buf);
        strcat(user_str,"\" size=\"2\" maxlength=\"2\"><br><br><p><h3>Action</h3></p><hr>Port Status: ");
        if (switch_times[event_id_tmp].switch_status)
            {
            strcat(user_str,"<input type=\"radio\" id=\"portstate\" name=\"switch_status\" value=\"on\" checked=\"checked\"><label for=\"portstate\">ON</label><input type=\"radio\" id=\"portstate\" name=\"switch_status\" value=\"off\"><label for=\"portstate\">OFF</label>");
            }
        else
            {
            strcat(user_str,"<input type=\"radio\" id=\"portstate\" name=\"switch_status\" value=\"on\"><label for=\"portstate\">ON</label><input type=\"radio\" id=\"portstate\" name=\"switch_status\" value=\"off\" checked=\"checked\"><label for=\"portstate\">OFF</label>");
            } 
        strcat(user_str,"<br><hr><br>");
        if (strcmp(config.use_authorization,"yes") == 0)
            strcat(user_str,"Station Password:<br><input type=\"password\" name=\"station_password\" maxlength=\"64\" value=\"\"><br><br>");
        strcat(user_str,"<p><a href=\"/cfgsavactions\"><button type=\"submit\">SAVE</button></a></p></form><p><a href=\"/\"><button type=\"submit\">GO BACK</button></a></p>");
        }
    strcat(user_str,"<br>");
    strcat(user_str,FIRMWARE_VERSION);
    strcat(user_str," Last:");
    strcat(user_str, strftime_buf);              
    strcat(user_str,"</body></html>");
    cfg_err = 0;
}


